#INCLUDE "dcdialog.CH"
#INCLUDE "appevent.CH"

#DEFINE CRLF Chr(13)+Chr(10)

FUNCTION Main()

LOCAL GetList[0], GetOptions, oButton, oMenu, bMenuAction,  oStatic, oWindow, ;
      lDisabled := .f., cCaption

PRIVATE oButtPicker, oButtPickerCaption

cCaption := 'Welcome;to;Butt-Picker'
IF File('BUTTPICKER.XPF')
  REST FROM BUTTPICKER
  cCaption := M->oButtPickerCaption
ENDIF

DC_BitmapTransparentColor( {192,192,192})
DC_ExpressButtonStyle(DC_XbpPushButtonXPDefault():new())
DC_PopupButtonStyle(DC_XbpPushButtonXPDefault():new())

@ 0,0 DCSTATIC TYPE XBPSTATIC_TYPE_TEXT SIZE 280,100 PIXEL PIXEL OBJECT oStatic ;
      RESIZE DCGUI_RESIZE_RESIZEONLY

@ 20,20 DCPUSHBUTTONXP ;
      CAPTION cCaption ;
      SIZE 240,60 ;
      OBJECT oButton ;
      GRADIENT 1.1 ;
      TOOLTIP 'Click me for my menu' ;
      RESIZE DCGUI_RESIZE_RESIZEONLY ;
      ACCELKEY xbeK_ALT_M ;
      BORDERCOLOR {255,153,51} ;
      PARENT oStatic ;
      CONFIG M->oButtPicker ;
      EVAL {|o|o:resize := {||DC_GetRefresh(GetList,'SIZE')} } ;
      WHEN {||!lDisabled} ;
      ACTION {||nil}

@ 0, 20 DCSAY {||Alltrim(Str(oButton:currentSize()[1])) + ' x ' + Alltrim(Str(oButton:currentSize()[2]))} ;
      SAYSIZE 100 FONT '10.Lucida Console Bold' PARENT oStatic PIXEL ;
      RESIZE DCGUI_RESIZE_REPOSONLY_Y ;
      ID 'SIZE'

DCGETOPTIONS SAYWIDTH 100 PIXEL RESIZE

DCREAD GUI FIT TITLE 'Button Builder' OPTIONS GetOptions SETAPPWINDOW ;
   EVAL {|o,t|oWindow := o, SetWindowSize(o), ;
              t := Thread():new(), Sleep(5), t:start({||OptionsWindow(oButton,oWindow,@lDisabled,GetList)}), ;
              Sleep(100), o:toFront()}

RETURN nil

* -----------------

STATIC FUNCTION OptionsWindow( oButton, oWindow, lDisabled, aButtonGetList )

LOCAL GetList[0], GetOptions, oColorGroup, oGradientStyleGroup, oFocusGroup, ;
      oBitmapGroup, oBitmapAlignGroup, aFiles, oShadowGroup, oCaptionGroup, i, ;
      bGetSet, oTextShadowGroup

DEFAULT oButton:bitmapSource := ''
DEFAULT oButton:tileBitmapSource := ''
DEFAULT oButton:font := ''
DEFAULT oButton:mouseOverFont := ''
oButton:bitmapSource := Pad(oButton:bitmapSource,100)
oButton:tileBitmapSource := Pad(oButton:tileBitmapSource,100)
oButton:caption := Pad(oButton:caption,100)
oButton:font := Pad(oButton:font,100)
oButton:mouseOverFont := Pad(oButton:mouseOverFont,100)
oButton:menuButtonWidth := 15

aFiles := { {"JPEG Images","*.JPG"}, ;
            {"Bitmap Images","*.BMP"}, ;
            {"GIF Images","*.GIF"}, ;
            {"PNG Images","*.PNG"}, ;
            {"All Files","*.*"} }

@ 0,0 DCGROUP oColorGroup SIZE 40,14 CAPTION 'Colors'

@ 1,2 DCSAY 'Foreground' GET oButton:fgColor ;
      POPUP {|n|SetColor(oButton,@oButton:fgColor,'Foreground')} ;
      PARENT oColorGroup

@ 2,2 DCSAY 'Background' GET oButton:bgColor ;
      POPUP {|n|SetColor(oButton,@oButton:bgColor,'Background')} ;
      PARENT oColorGroup

@ 3,2 DCSAY 'Foreground (Mouse-Over)' GET oButton:fgColorMouse ;
      POPUP {|n|SetColor(oButton,@oButton:fgColorMouse,'Foreground (Mouse-Over)')} ;
      PARENT oColorGroup

@ 4,2 DCSAY 'Background (Mouse-Over)' GET oButton:bgColorMouse ;
      POPUP {|n|SetColor(oButton,@oButton:bgColorMouse,'Background (Mouse-Over)')} ;
      PARENT oColorGroup

@ 5,2 DCSAY 'Foreground (Clicked)' GET oButton:fgColorClick ;
      POPUP {|n|SetColor(oButton,@oButton:fgColorClick,'Foreground (Clicked)')} ;
      PARENT oColorGroup

@ 6,2 DCSAY 'Background (Clicked)' GET oButton:bgColorClick ;
      POPUP {|n|SetColor(oButton,@oButton:bgColorClick,'Background (Clicked)')} ;
      PARENT oColorGroup

@ 7,2 DCSAY 'Border' GET oButton:borderColor ;
      POPUP {|n|SetColor(oButton,@oButton:borderColor,'Border')} ;
      PARENT oColorGroup

@ 8,2 DCSAY 'Focus Rectangle' GET oButton:focusRectColor ;
      POPUP {|n|SetColor(oButton,@oButton:focusRectColor,'Focus Rectangle')} ;
      PARENT oColorGroup

@ 9,2 DCSAY 'Disabled Foreground' GET oButton:disabledFGColor ;
      POPUP {|n|SetColor(oButton,@oButton:disabledFGColor,'Disabled Foreground')} ;
      PARENT oColorGroup

@10,2 DCSAY 'Disabled Background' GET oButton:disabledBGColor ; 
      POPUP {|n|SetColor(oButton,@oButton:disabledBGColor,'Disabled Background')} ;
      PARENT oColorGroup

@11,2 DCSAY 'Selected Foreground' GET oButton:fgColorSelected ;
      POPUP {|n|SetColor(oButton,@oButton:fgColorSelected,'Selected Foreground')} ;
      PARENT oColorGroup

@12,2 DCSAY 'Selected Background' GET oButton:bgColorSelected ;
      POPUP {|n|SetColor(oButton,@oButton:bgColorSelected,'Selected Background')} ;
      PARENT oColorGroup

@ 0, 42 DCGROUP oGradientStyleGroup SIZE 25,9 CAPTION 'Gradient Style'

@ 1,2 DCRADIO oButton:gradientStyle VALUE 0 PROMPT 'None' PARENT oGradientStyleGroup ACTION {||oButton:invalidateRect()}
@ 2,2 DCRADIO oButton:gradientStyle VALUE 1 PROMPT 'Vertical (top to bottom)' PARENT oGradientStyleGroup ACTION {||oButton:invalidateRect()}
@ 3,2 DCRADIO oButton:gradientStyle VALUE 2 PROMPT 'Vertical (bottom to top)' PARENT oGradientStyleGroup ACTION {||oButton:invalidateRect()}
@ 4,2 DCRADIO oButton:gradientStyle VALUE 3 PROMPT 'Horizontal (left to right)' PARENT oGradientStyleGroup ACTION {||oButton:invalidateRect()}
@ 5,2 DCRADIO oButton:gradientStyle VALUE 4 PROMPT 'Horizontal (right to left)' PARENT oGradientStyleGroup ACTION {||oButton:invalidateRect()}
@ 6,2 DCRADIO oButton:gradientStyle VALUE 5 PROMPT 'Concentric (inner to outer)' PARENT oGradientStyleGroup ACTION {||oButton:invalidateRect()}
@ 7,2 DCRADIO oButton:gradientStyle VALUE 6 PROMPT 'Concentric (outer to inner)' PARENT oGradientStyleGroup ACTION {||oButton:invalidateRect()}
@ 8,2 DCRADIO oButton:gradientStyle VALUE 9 PROMPT 'Windows' PARENT oGradientStyleGroup ACTION {||oButton:invalidateRect()}

@ 0, 69 DCGROUP oFocusGroup SIZE 20,6 CAPTION 'Focus Rectangle Style'

@ 1,2 DCRADIO oButton:focusRectStyle VALUE 0 PROMPT 'None' PARENT oFocusGroup
@ 2,2 DCRADIO oButton:focusRectStyle VALUE 1 PROMPT 'Dotted Interior' PARENT oFocusGroup ACTION {||oButton:invalidateRect()}
@ 3,2 DCRADIO oButton:focusRectStyle VALUE 2 PROMPT 'Normal Outline' PARENT oFocusGroup ACTION {||oButton:invalidateRect()}
@ 4,2 DCRADIO oButton:focusRectStyle VALUE 3 PROMPT 'Heavy Outline' PARENT oFocusGroup ACTION {||oButton:invalidateRect()}

@ 14, 0 DCGROUP oBitmapAlignGroup SIZE 20,10 CAPTION 'Bitmap Alignment'

@ 1,2 DCRADIO oButton:alignBitmap VALUE XBPALIGN_TOP    + XBPALIGN_LEFT PROMPT 'Left / Top' PARENT oBitmapAlignGroup ACTION {||oButton:configureCaptionArray()}
@ 2,2 DCRADIO oButton:alignBitmap VALUE XBPALIGN_LEFT   + XBPALIGN_VCENTER PROMPT 'Left / VCenter' PARENT oBitmapAlignGroup ACTION {||oButton:configureCaptionArray()}
@ 3,2 DCRADIO oButton:alignBitmap VALUE XBPALIGN_RIGHT  + XBPALIGN_TOP     PROMPT 'Right / Top' PARENT oBitmapAlignGroup ACTION {||oButton:configureCaptionArray()}
@ 4,2 DCRADIO oButton:alignBitmap VALUE XBPALIGN_RIGHT  + XBPALIGN_VCENTER PROMPT 'Right / VCenter' PARENT oBitmapAlignGroup ACTION {||oButton:configureCaptionArray()}
@ 5,2 DCRADIO oButton:alignBitmap VALUE XBPALIGN_TOP    + XBPALIGN_HCENTER PROMPT 'Top / HCenter' PARENT oBitmapAlignGroup ACTION {||oButton:configureCaptionArray()}
@ 6,2 DCRADIO oButton:alignBitmap VALUE XBPALIGN_BOTTOM + XBPALIGN_LEFT    PROMPT 'Bottom / Left' PARENT oBitmapAlignGroup ACTION {||oButton:configureCaptionArray()}
@ 7,2 DCRADIO oButton:alignBitmap VALUE XBPALIGN_BOTTOM + XBPALIGN_HCENTER PROMPT 'Bottom / HCenter' PARENT oBitmapAlignGroup ACTION {||oButton:configureCaptionArray()}
@ 8,2 DCRADIO oButton:alignBitmap VALUE XBPALIGN_BOTTOM + XBPALIGN_RIGHT   PROMPT 'Bottom / Right' PARENT oBitmapAlignGroup ACTION {||oButton:configureCaptionArray()}

@ 9,42 DCGROUP oTextShadowGroup SIZE 40,5 CAPTION 'Text Shadow'

@ 1,2 DCCHECKBOX oButton:isTextShadow PROMPT 'Paint Text Shadow' PARENT oTextShadowGroup ACTION {||oButton:invalidateRect()}
@ 2,2 DCSAY 'Foreground Color' GET oButton:textShadowColor SAYSIZE 13 ;
      POPUP {|n|SetColor(oButton,@oButton:textShadowColor,'Text Shadow')} ;
      PARENT oTextShadowGroup WHEN {||oButton:isTextShadow}
@ 3,2 DCSAY 'Offset in Pixels' GET oButton:textShadowOffset PICTURE '99' VALID {||oButton:invalidateRect(),.t.} ;
      PARENT oTextShadowGroup SAYSIZE 13 WHEN {||oButton:isTextShadow}

@ 24,0 DCGROUP oShadowGroup SIZE 20,7 CAPTION 'Shadow Type'
FOR i := 0 TO 4
  @ i+1,2 DCRADIO oButton:shadowType VALUE i PROMPT IIF(i==0,'None','Type ' + Alltrim(Str(i))) PARENT oShadowGroup ;
        ACTION {||oButton:invalidateRect()}
NEXT
FOR i := 5 TO 9
  @ i-4,11 DCRADIO oButton:shadowType VALUE i PROMPT 'Type ' + Alltrim(Str(i)) PARENT oShadowGroup ;
        ACTION {||oButton:invalidateRect()}
NEXT

@ 14, 22 DCGROUP oBitmapGroup SIZE 67,6 CAPTION 'Bitmap Options'

@ 1,2 DCSAY 'Bitmap Image' GET oButton:bitmapSource GETSIZE 40 ;
      POPUP {|c|DC_PopFile( c, nil, nil, 'Load an Image...', aFiles )} ;
      PARENT oBitmapGroup VALID {||oButton:setBitmap(Alltrim(oButton:bitmapSource)),.t.}

@ 2,2 DCSAY 'Bitmap Tile Image' GET oButton:tileBitmapSource GETSIZE 40 ;
      POPUP {|c|DC_PopFile( c, nil, nil, 'Load an Image...', aFiles )} ;
      PARENT oBitmapGroup VALID {||oButton:setBitmapTile(Alltrim(oButton:tileBitmapSource)),.t.}

@ 3,2 DCSAY 'Bitmap Offset' GET oButton:bitmapOffset PICTURE '99' PARENT oBitmapGroup ;
      VALID {||oButton:configureCaptionArray(),.t.}

@ 4,2 DCSAY 'Bitmap Scale' GET oButton:bitmapScale PICTURE '9.9' PARENT oBitmapGroup ;
      VALID {||oButton:configureCaptionArray(),.t.}

@ 20, 22 DCGROUP oCaptionGroup SIZE 67,6 CAPTION 'Caption Options'

@ 1,2 DCSAY 'Text' GET oButton:caption GETSIZE 40 VALID {||oButton:configureCaptionArray()} ;
      PARENT oCaptionGroup

@ 2,2 DCSAY 'Font (Normal)' GET oButton:font POPUP {|c|DC_PopFont(c)} ;
      PARENT oCaptionGroup GETSIZE 40 VALID {||oButton:setFontName(oButton:font),.t.}

@ 3,2 DCSAY 'Font (Mouse-Over)' GET oButton:mouseOverFont POPUP {|c|DC_PopFont(c)} ;
      PARENT oCaptionGroup GETSIZE 40 VALID {||oButton:setFontNameMouseOver(oButton:mouseOverFont)}

@ 4,2 DCSAY 'Scale (Mouse-Over)' GET oButton:mouseOverScale PICTURE '9.9' ;
      PARENT oCaptionGroup

@ 27,30 DCSAY 'Radius' GET oButton:radius PICTURE '999' VALID {||oButton:invalidateRect(),.t.} SAYSIZE 10

@ 28,30 DCSAY 'Gradient Step' GET oButton:gradientStep PICTURE '99.9' VALID {||oButton:invalidateRect(),.t.} SAYSIZE 10

@ 29,30 DCSAY 'Gradient Level' GET oButton:gradientLevel PICTURE '999' VALID {||oButton:invalidateRect(),.t.} SAYSIZE 10

@ 28,60 DCCHECKBOX oButton:gradientReverse PROMPT 'Reverse Gradient on Mouse-Over' ACTION {||oButton:invalidateRect(),.t.}

@ 29,60 DCCHECKBOX oButton:disabledBmp PROMPT 'Gray Bitmap when Disabled' ACTION {||oButton:invalidateRect(),.t.}

@ 30,60 DCCHECKBOX oButton:enableSelect PROMPT 'Enable SELECT Mode' ;
        ACTION {||oButton:selected := oButton:enableSelect, oButton:invalidateRect()}

bGetSet := {|u|IIF(u#nil,oButton:menuBlock:=IIF(u,{||Msgbox('I am a menu button')},nil),nil),!Empty(oButton:menuBlock)}

@ 30,30 DCCHECKBOX bGetSet PROMPT 'Add Menu Button' ACTION {||oButton:invalidateRect()}

@ 32,0 DCPUSHBUTTON CAPTION 'Repaint Button' SIZE 20,1.2 ;
       ACTION {||oButton:configureCaptionArray()}

@ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Create Source (Single Button)' ;
       ACTION {||CreateSource(oButton,.f.,oWindow)} ;
       SIZE 25, 1.2

@ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION 'Create Source (Configuration)' ;
       ACTION {||CreateSource(oButton,.t.,oWindow)} ;
       SIZE 25, 1.2

@ DCGUI_ROW, DCGUI_COL + 10 DCPUSHBUTTON CAPTION {||IIF(lDisabled,'Enable','Disable') + ' Button'} ;
       ACTION {||lDisabled := !lDisabled, DC_GetRefresh(GetList),DC_GetRefresh(aButtonGetList),oButton:invalidateRect()} ;
       SIZE 15, 1.2

DCGETOPTIONS SAYWIDTH 130 SAYRIGHTBOTTOM

DCREAD GUI FIT TITLE 'Button Options' OPTIONS GetOptions

RETURN nil

* -----------------

STATIC FUNCTION SetWindowSize( oWindow )

IF Valtype(M->oButtPicker) == 'O' .AND. IsMemberVar(M->oButtPicker,'CARGO') .AND. !Empty(M->oButtPicker:cargo)
  oWindow:setSize(M->oButtPicker:cargo)
ENDIF

RETURN nil

* -----------------

PROC Appsys
RETURN

* --------------

STATIC FUNCTION SetFocusStyle( self )

LOCAL GetList[0]

::disable()
@ 0,0 DCRADIO ::focusRectStyle VALUE 0 PROMPT 'No Focus Rectangle'
@ 1,0 DCRADIO ::focusRectStyle VALUE 1 PROMPT 'Dotted Interior Focus Rectangle'
@ 2,0 DCRADIO ::focusRectStyle VALUE 2 PROMPT 'Normal Outline Focus Rectangle'
@ 3,0 DCRADIO ::focusRectStyle VALUE 3 PROMPT 'Heavy Outline Focus Rectangle'

DCREAD GUI FIT ADDBUTTONS TITLE 'Choose Focus Rectangle Style' MODAL
::enable()

RETURN nil

* --------------

STATIC FUNCTION SetColor( oButton, nColor, cTitle )

LOCAL aRGB, nSaveColor := nColor

cTitle := 'Choose Button ' + cTitle
aRGB := DC_PopColor( GraGetRGBIntensity( nColor ), 2, .t., cTitle,.t. )

nColor := GraMakeRGBColor(aRGB)

IF nColor == NIL
  nColor := nSaveColor
ENDIF

oButton:invalidateRect()

RETURN nColor

* --------------

STATIC FUNCTION SetRadius( oButton )

LOCAL GetList[0]

oButton:disable()

@ 0,0 DCSPINBUTTON oButton:radius RANGE 0,50 SIZE 10

DCREAD GUI FIT ADDBUTTONS TITLE 'Button Radius' OWNER SetAppWindow()

oButton:enable()
oButton:invalidateRect()

RETURN nil

* --------------

STATIC FUNCTION SetScale( oButton )

LOCAL GetList[0], aScale := { 1.0, 1.1, 1.2, 1.3, 1.5, 1.6, 1.7, 1.8, 1.9, 2.0 }

oButton:disable()

@ 0,0 DCGET oButton:mouseOverScale COMBO DATA aScale HEIGHT 20 WIDTH 20 PICTURE '9.99'

DCREAD GUI FIT ADDBUTTONS TITLE 'Button Radius' OWNER SetAppWindow()

oButton:enable()
oButton:invalidateRect()

RETURN nil

* --------------

STATIC FUNCTION SetBitmapOffset( oButton )

LOCAL GetList[0]

oButton:disable()

@ 0,0 DCSPINBUTTON oButton:bitmapOffset RANGE 0,100 SIZE 10

DCREAD GUI FIT ADDBUTTONS TITLE 'Bitmap Offset' OWNER SetAppWindow() ENTEREXIT

oButton:enable()

oButton:ConfigureCaptionArray()

RETURN nil

* --------------

STATIC FUNCTION SetBitmapScale( oButton )

LOCAL GetList[0]

oButton:disable()

@ 0,0 DCGET oButton:bitmapScale PICTURE '9.9'

DCREAD GUI FIT ADDBUTTONS TITLE 'Bitmap Scale' OWNER SetAppWindow() ENTEREXIT

oButton:enable()

oButton:configureCaptionArray()

RETURN nil

* --------------

STATIC FUNCTION SetCaption( oButton )

LOCAL GetList[0]
oButton:caption := Pad(oButton:caption,100)

oButton:disable()

@ 0,0 DCGET oButton:caption

DCREAD GUI FIT ADDBUTTONS TITLE 'Caption Text' OWNER SetAppWindow() ENTEREXIT

oButton:caption := Trim(oButton:caption)

oButton:enable()

oButton:configureCaptionArray()

RETURN nil

* --------------

STATIC FUNCTION SetFont( oButton, nWhich )

LOCAL cFont := DC_PopFont()

IF Valtype(cFont) == 'C'
  IF nWhich == 1
    oButton:setFontName(cFont)
  ELSE
    oButton:setFontNameMouseOver(cFont)
  ENDIF
ENDIF

RETURN nil

* --------------

STATIC FUNCTION SetBitmap( oButton, nWhich )

LOCAL cFileName

oButton:disable()

cFileName := DC_PopFile( nil, nil, nil, 'Load an Image...', ;
                         { {"JPEG Images","*.JPG"}, ;
                           {"Bitmap Images","*.BMP"}, ;
                           {"GIF Images","*.GIF"}, ;
                           {"PNG Images","*.PNG"}, ;
                           {"All Files","*.*"} } )

IF !Empty(cFileName)
  IF nWhich == 1
    oButton:setBitMap(cFileName)
  ELSE
    oButton:setBitMapTile(cFileName)
  ENDIF
ENDIF

oButton:enable()

RETURN nil

* ---------------

STATIC FUNCTION SetBitmapAlignment( oButton )

LOCAL GetList[0], lStatus

oButton:disable()

@ 0,0 DCRADIO oButton:alignBitmap VALUE XBPALIGN_TOP    + XBPALIGN_LEFT PROMPT 'Left / Top'
@ 1,0 DCRADIO oButton:alignBitmap VALUE XBPALIGN_LEFT   + XBPALIGN_VCENTER PROMPT 'Left / VCenter'
@ 2,0 DCRADIO oButton:alignBitmap VALUE XBPALIGN_RIGHT  + XBPALIGN_TOP     PROMPT 'Right / Top'
@ 3,0 DCRADIO oButton:alignBitmap VALUE XBPALIGN_RIGHT  + XBPALIGN_VCENTER PROMPT 'Right / VCenter'
@ 4,0 DCRADIO oButton:alignBitmap VALUE XBPALIGN_TOP    + XBPALIGN_HCENTER PROMPT 'Top / HCenter'
@ 5,0 DCRADIO oButton:alignBitmap VALUE XBPALIGN_BOTTOM + XBPALIGN_LEFT    PROMPT 'Bottom / Left'
@ 6,0 DCRADIO oButton:alignBitmap VALUE XBPALIGN_BOTTOM + XBPALIGN_HCENTER PROMPT 'Bottom / HCenter'
@ 7,0 DCRADIO oButton:alignBitmap VALUE XBPALIGN_BOTTOM + XBPALIGN_RIGHT   PROMPT 'Bottom / Right'

DCREAD GUI FIT ADDBUTTONS TITLE 'Bitmap Alignment' MODAL TO lStatus

oButton:enable()

IF lStatus
  oButton:ConfigureCaptionArray()
ENDIF

RETURN nil

* --------------

STATIC FUNCTION SetGradient( oButton )

LOCAL GetList[0], nStep := 0

oButton:disable()

@ 0,0 DCGET oButton:gradientStep PICTURE '9.9' POPUP {|c|c}

DCREAD GUI FIT ADDBUTTONS TITLE 'Button Gradient Step' MODAL OWNER SetAppWindow() ENTEREXIT

oButton:enable()

oButton:invalidateRect()

RETURN nil

* --------------

STATIC FUNCTION SetGradientStyle( oButton )

LOCAL GetList[0], nStep := 0

oButton:disable()

@ 0,0 DCRADIO oButton:gradientStyle VALUE 1 PROMPT 'Vertical'
@ 1,0 DCRADIO oButton:gradientStyle VALUE 2 PROMPT 'Horizontal'
@ 2,0 DCRADIO oButton:gradientStyle VALUE 3 PROMPT 'Concentric'

DCREAD GUI FIT ADDBUTTONS TITLE 'Button Gradient Style' MODAL OWNER SetAppWindow() ENTEREXIT

oButton:enable()

oButton:invalidateRect()

RETURN nil

* -------------

STATIC FUNCTION SetShadowtype( oButton )

LOCAL GetList[0]

oButton:disable()

@ 0,0 DCGET oButton:shadowType PICTURE '9'

DCREAD GUI FIT ADDBUTTONS TITLE 'Shadow Type' OWNER SetAppWindow() ENTEREXIT MODAL

oButton:enable()

oButton:invalidateRect()

RETURN nil

* -------------

STATIC FUNCTION CreateSource( self, lConfig, oWindow )

LOCAL cSource, GetList[0], GetOptions, cToolTip, nAccelKey, c

DEFAULT lConfig := .f.

IF lConfig

  cSource := 'oConfig := DC_XbpPushButtonXPConfig():new()' + CRLF
  cSource += 'oConfig:bitmapOffset := ' + Alltrim(Str(::bitmapOffset)) + CRLF
  cSource += 'oConfig:captionOffset := ' + Alltrim(Str(::captionOffset)) + CRLF
  cSource += 'oConfig:fgColorMouse := ' + Alltrim(Str(::fgColorMouse)) + CRLF
  cSource += 'oConfig:bgColorMouse := ' + Alltrim(Str(::bgColorMouse)) + CRLF
  cSource += 'oConfig:fgColor := ' + Alltrim(Str(::fgColor)) + CRLF
  cSource += 'oConfig:bgColor := ' + Alltrim(Str(::bgColor)) + CRLF
  cSource += 'oConfig:fgColorSelected := ' + Alltrim(Str(::fgColorSelected)) + CRLF
  cSource += 'oConfig:bgColorSelected := ' + Alltrim(Str(::bgColorSelected)) + CRLF
  cSource += 'oConfig:fgColorClick := ' + Alltrim(Str(::fgColorClick)) + CRLF
  cSource += 'oConfig:bgColorClick := ' + Alltrim(Str(::bgColorClick)) + CRLF
  cSource += 'oConfig:gradientStep := ' + Alltrim(Str(::gradientStep)) + CRLF
  cSource += 'oConfig:gradientStyle := ' + Alltrim(Str(::gradientStyle)) + CRLF
  cSource += 'oConfig:gradientReverse := ' + IIF( ::gradientReverse,'.T.','.F.') + CRLF
  cSource += 'oConfig:radius := ' + Alltrim(Str(::radius)) + CRLF
  cSource += 'oConfig:outline := ' + IIF( ::outline,'.T.','.F.') + CRLF
  cSource += 'oConfig:font := ' + IIF(Empty(c := Font2String(::Font)),'nil',c) + CRLF
  cSource += 'oConfig:mouseOverFont := ' + IIF(Empty(c := Font2String(::mouseOverFont)),'nil',c) + CRLF
  cSource += 'oConfig:mouseOverScale := ' + Alltrim(Str(::mouseOverScale)) + CRLF
  cSource += 'oConfig:bitmapScale := ' + Alltrim(Str(::bitmapScale)) + CRLF
  cSource += 'oConfig:borderColor := ' + Alltrim(Str(::borderColor))  + CRLF
  cSource += 'oConfig:disabledFGColor := ' + Alltrim(Str(::disabledFGColor))  + CRLF
  cSource += 'oConfig:disabledBGColor := ' + Alltrim(Str(::disabledBGColor))  + CRLF
  cSource += 'oConfig:disabledBmp := ' + IIF( ::disabledBmp,'.T.','.F.' )  + CRLF
  cSource += 'oConfig:enableSelect := ' + IIF( ::enableSelect,'.T.','.F.' ) + CRLF
  cSource += 'oConfig:mouseOverSound := ' + IIF(Empty(c := DC_XtoC(::mouseOverSound)),'nil',c) + CRLF
  cSource += 'oConfig:tileBitMap := ' + IIF(Empty(c := DC_XtoC(::tileBitMap)),'nil',c) + CRLF
  cSource += 'oConfig:menuButtonWidth := ' + Alltrim(Str(::menuButtonWidth)) + CRLF
  cSource += 'oConfig:alignCaption := ' + Alltrim(Str(::alignCaption)) + CRLF
  cSource += 'oConfig:alignBitmap := ' + Alltrim(Str(::alignBitmap)) + CRLF
  cSource += 'oConfig:focusRectStyle := ' + Alltrim(Str(::focusRectStyle)) + CRLF
  cSource += 'oConfig:focusRectColor := ' + Alltrim(Str(::focusRectColor)) + CRLF
  cSource += 'oConfig:shadowtype := ' + Alltrim(Str(::shadowtype)) + CRLF
//  cSource += 'oConfig:isTextShadow := ' + IIF( ::textShadow,'.T.','.F.' ) + CRLF
  cSource += 'oConfig:textShadowColor := ' + Alltrim(Str(::textShadowColor)) + CRLF
  cSource += 'oConfig:textShadowOffset := ' + Alltrim(Str(::textShadowOffset)) + CRLF
  M->oButtPicker := DC_XbpPushButtonXPConfig():new()
  M->oButtPicker:bitmapOffset := ::bitmapOffset
  M->oButtPicker:captionOffset := ::captionOffset
  M->oButtPicker:fgColorMouse := ::fgColorMouse
  M->oButtPicker:bgColorMouse := ::bgColorMouse
  M->oButtPicker:fgColor := ::fgColor
  M->oButtPicker:bgColor := ::bgColor
  M->oButtPicker:fgColorSelected := ::fgColorSelected
  M->oButtPicker:bgColorSelected := ::bgColorSelected
  M->oButtPicker:fgColorClick := ::fgColorClick
  M->oButtPicker:bgColorClick := ::bgColorClick
  M->oButtPicker:gradientStep := ::gradientStep
  M->oButtPicker:gradientStyle := ::gradientStyle
  M->oButtPicker:gradientReverse := ::gradientReverse
  M->oButtPicker:radius := ::radius
  M->oButtPicker:outline := ::outline
  M->oButtPicker:font := ::Font
  M->oButtPicker:mouseOverFont := ::mouseOverFont
  M->oButtPicker:mouseOverScale := ::mouseOverScale
  M->oButtPicker:bitmapScale := ::bitmapScale
  M->oButtPicker:borderColor := ::borderColor
  M->oButtPicker:disabledFGColor := ::disabledFGColor
  M->oButtPicker:disabledBGColor := ::disabledBGColor
  M->oButtPicker:disabledBmp := ::disabledBmp
  M->oButtPicker:enableSelect := ::enableSelect
  M->oButtPicker:mouseOverSound := ::mouseOverSound
  M->oButtPicker:tileBitMap := ::tileBitMap
  M->oButtPicker:menuButtonWidth := ::menuButtonWidth
  M->oButtPicker:alignCaption := ::alignCaption
  M->oButtPicker:alignBitmap := ::alignBitmap
  M->oButtPicker:focusRectStyle := ::focusRectStyle
  M->oButtPicker:focusRectColor := ::focusRectColor
  M->oButtPicker:shadowType := ::shadowType
  M->oButtPicker:cargo := oWindow:currentSize()
  M->oButtPicker:enableSelect := ::enableSelect
  M->oButtPicker:isTextShadow := ::isTextShadow
  M->oButtPicker:textShadowColor := ::textShadowColor
  M->oButtPicker:textShadowOffset := ::textShadowOffset

  M->oButtPickerCaption := ::caption

  SAVE ALL LIKE oButtPicker* to BUTTPICKER

ELSE

  cSource := '@ 0,0 DCPUSHBUTTONXP ;' + CRLF
  cSource += '      SIZE ' + Alltrim(Str(::currentSize()[1])) + ', ' + Alltrim(Str(::currentSize()[2])) + ' ;' + CRLF
  IF !Empty(::caption)
    cSource += '      CAPTION ' + Alltrim(::caption) + ' ;' + CRLF
  ENDIF
  IF !Empty(::bitmapSource)
    cSource += '      BITMAP ' + Alltrim(DC_XtoC(::bitmapSource)) + ' ;' + CRLF
    cSource += '         ALIGN ' + Alltrim(Str(::alignBitmap)) + ' ;' + CRLF
    cSource += '         OFFSET ' + Alltrim(Str(::bitmapOffset)) + ' ;' + CRLF
    cSource += '         SCALE ' + Alltrim(Str(::bitmapScale)) + ' ;' + CRLF
  ENDIF
  IF !Empty(::tileBitmapSource)
    cSource += '      TILEBITMAP ' + Alltrim(DC_XtoC(::tileBitmapSource)) + ' ;' + CRLF
  ENDIF
  IF !Empty(::gradientStep)
    cSource += '      GRADIENT ' + Alltrim(Str(::gradientStep)) + ' ;' + CRLF
    IF ::gradientReverse
      cSource += '        REVERSE  ;' + CRLF
    ENDIF
  ENDIF

  cSource += '      COLOR ' + DC_ArrayString(GraGetRGBIntensity(::fgColor)) + ',' + ;
                              DC_ArrayString(GraGetRGBIntensity(::bgColor)) + ' ;' + CRLF
  cSource += '      MOUSECOLOR ' + DC_ArrayString(GraGetRGBIntensity(::fgColorMouse)) + ',' + ;
                                   DC_ArrayString(GraGetRGBIntensity(::bgColorMouse)) + ' ;' + CRLF
  cSource += '      CLICKCOLOR ' + DC_ArrayString(GraGetRGBIntensity(::fgColorClick)) + ',' + ;
                                   DC_ArrayString(GraGetRGBIntensity(::bgColorClick)) + ' ;' + CRLF
  cSource += '      BORDERCOLOR ' + DC_ArrayString(GraGetRGBIntensity(::borderColor)) + ' ;' + CRLF

  cSource += '      RADIUS ' + Alltrim(Str(::radius)) + ' ;' + CRLF
  IF !Empty(::font)
    cSource += '      FONT ' + Alltrim(::font) + ' ;' + CRLF
  ENDIF
  IF !Empty(::actionBlock)
    cSource += '      ACTION ' + Alltrim(DC_GetCodeBlockText(::actionBlock)) + ' ;' + CRLF
  ENDIF
  IF !Empty(::menuBlock)
    cSource += '      MENUACTION ' + Alltrim(DC_GetCodeBlockText(::menuBlock)) + ' ;' + CRLF
  ENDIF
  cToolTip := DC_GetProperty( self, cGETLIST_TOOLTIP )
  IF !Empty(cToolTip)
    cSource += '      TOOLTIP ' + Alltrim(cTooltip) + ' ;' + CRLF
  ENDIF
  nAccelKey := DC_GetProperty( self, nGETLIST_ACCELKEY )
  IF !Empty(nAccelKey)
    cSource += '      ACCELKEY ' + DC_AppKeyDefine(nAccelKey) + ' ;' + CRLF
  ENDIF

ENDIF

@ 0,0 DCMULTILINE cSource SIZE 150,20 FONT '10.Lucida Console'

DCGETOPTIONS RESIZE RESIZEDEFAULT DCGUI_RESIZE_RESIZEONLY

DCREAD GUI FIT TITLE 'Button Source' MODAL OPTIONS GetOptions

RETURN nil


* -----------------

STATIC FUNCTION Font2String( xFont )

IF Valtype(xFont) == 'O'
  xFont := DC_FontCompoundName(xFont)
ELSEIF Empty(xFont)
  xFont := 'nil'
  RETURN xFont
ENDIF

RETURN '"' + xFont + '"'
